{

  open Lexing
  open IMPParser
  
}

let digit = ['0'-'9']
let number = digit+
let label = ['a'-'z' '_']+
  
rule token = parse
  | ['\n']
      { new_line lexbuf; token lexbuf }
  | [' ' '\t' '\r']+
      { token lexbuf }
  | number as n
      { INT(int_of_string n) }
  | ".text"
      { TEXT }
  | ".data"
      { DATA }
  | "print"
      { PRINT }
  | "exit"
      { EXIT }
  | label as lab
      { LABEL(lab) }
  | ";"
      { SEMI }
  | ":"
      { COLON }
  | "("
      { LP }
  | ")"
      { RP }
  | _
      { failwith ("Unknown character : " ^ (lexeme lexbuf)) }
  | eof
      { EOF }
