%{

  open Lexing

%}

(* Base *)
%token TEXT DATA
%token PRINT EXIT
%token SEMI
%token COLON
%token <int>INT
%token <string>LABEL
%token EOF
%token LP RP

%start program
%type <IMP.program> program

%%

program:
| TEXT text=list(instruction) DATA data=list(data_declaration) EOF
    { { text; data } }
| error { let pos = $startpos in
          let message =
            Printf.sprintf "Syntax error at %d, %d" pos.pos_lnum (pos.pos_cnum - pos.pos_bol)
          in
          failwith message }
;

instruction:
| PRINT LP e=expression RP SEMI { IMPInstr.Print(e) }
| EXIT SEMI                     { IMPInstr.Exit }
;

expression:
| i=INT { IMPExpr.Immediate(i) }
;

data_declaration:
| l=LABEL COLON v=INT { l, v }
;

