module S = IMP
module I = IMPInstr
module T = ART

let new_label =
  let cpt = ref 0 in
  fun () -> incr cpt; Printf.sprintf "label_%i" !cpt

let rec translate_instruction = function
      
  | I.Print(e) ->
    [ T.Print(e) ]
      
  | I.Exit ->
    [ T.Exit ]
      
  | _ -> failwith "not implemented (IMPtoART.translate_instruction)"

      
and translate_sequence s =
  List.flatten (List.map translate_instruction s)

let translate_program p =
  { T.text = translate_sequence S.(p.text);
    T.data = S.(p.data) }
